Loading...
Searching...
No Matches
Ogre::PanelOverlayElement Class Reference
Optional Components » Overlay

OverlayElement representing a flat, single-material (or transparent) panel which can contain other elements. More...

`#include <OgrePanelOverlayElement.h>`

Inheritance diagram for Ogre::PanelOverlayElement:
[legend]

## Public Member Functions

| PanelOverlayElement (const String &name)
| Constructor.
virtual | ~PanelOverlayElement ()
void | _releaseManualHardwareResources () override
| Notifies that hardware resources were lost.
void | _restoreManualHardwareResources () override
| Notifies that hardware resources should be restored.
void | _updateRenderQueue (RenderQueue *queue) override
| Overridden from OverlayContainer.
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
Real | getTileX (ushort layer=0) const
Real | getTileY (ushort layer=0) const
| Gets the number of times the texture should repeat vertically.
const String & | getTypeName (void) const override
| Gets the type name of the element.
void | getUV (Real &u1, Real &v1, Real &u2, Real &v2) const
| Get the uv coordinates for the panel.
void | initialise (void) override
| Initialise.
bool | isTransparent (void) const
| Returns whether this panel is transparent.
void | setTiling (Real x, Real y, ushort layer=0)
| Sets the number of times textures should repeat.
void | setTransparent (bool isTransparent)
| Sets whether this panel is transparent (used only as a grouping level), or if it is actually rendered.
void | setUV (Real u1, Real v1, Real u2, Real v2)
| Sets the texture coordinates for the panel.
Public Member Functions inherited from Ogre::OverlayContainer
| OverlayContainer (const String &name)
| Constructor: do not call direct, use OverlayManager::createOverlayElement.
virtual | ~OverlayContainer ()
void | _addChild (OverlayElement *elem)
void | _notifyParent (OverlayContainer *parent, Overlay *overlay) override
| Overridden from OverlayElement.
void | _notifyViewport () override
| Overridden from OverlayElement.
void | _notifyWorldTransforms (const Matrix4 &xform) override
| Overridden from OverlayElement.
ushort | _notifyZOrder (ushort newZOrder) override
| Overridden from OverlayElement.
void | _positionsOutOfDate (void) override
| Tell the object and its children to recalculate.
void | _removeChild (const String &name)
void | _removeChild (OverlayElement *elem)
void | _update (void) override
| Overridden from OverlayElement.
virtual void | addChild (OverlayElement *elem)
| Adds another OverlayElement to this container.
virtual void | addChildImpl (OverlayContainer *cont)
| Add a nested container to this container.
virtual void | addChildImpl (OverlayElement *elem)
| Adds another OverlayElement to this container.
OverlayElement * | clone (const String &instanceName) override
void | copyFromTemplate (OverlayElement *templateOverlay) override
OverlayElement * | findElementAt (Real x, Real y) override
| This returns a OverlayElement at position x,y.
virtual OverlayElement * | getChild (const String &name)
| Gets the named child of this container.
virtual ChildContainerIterator | getChildContainerIterator (void)
| Gets an iterator for just the container children of this object.
virtual ChildIterator | getChildIterator (void)
const ChildMap & | getChildren () const
| Gets all the children of this object.
virtual bool | isChildrenProcessEvents () const
| Should this container pass events to their children.
bool | isContainer () const override
| Overridden from OverlayElement.
virtual void | removeChild (const String &name)
| Removes a named element from this container.
virtual void | setChildrenProcessEvents (bool val)
| Should this container pass events to their children.
Public Member Functions inherited from Ogre::OverlayElement
| OverlayElement (const String &name)
| Constructor: do not call direct, use OverlayManager::createElement.
virtual | ~OverlayElement ()
virtual void | _getClippingRegion (RealRect &clippingRegion)
| Gets the clipping region of the element.
virtual Real | _getDerivedLeft (void)
| Gets the 'left' position as derived from own left and that of parents.
virtual Real | _getDerivedTop (void)
| Gets the 'top' position as derived from own left and that of parents.
Real | _getHeight (void) const
| Gets the height of this element in relation to the screen (where 1.0 = screen height).
Real | _getLeft (void) const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
virtual Real | _getRelativeHeight (void)
| Gets the 'height' as derived from own height and metrics mode.
virtual Real | _getRelativeWidth (void)
| Gets the 'width' as derived from own width and metrics mode.
Real | _getTop (void) const
| Gets the top of this element in relation to the screen (where 0 = far top, 1.0 = far bottom).
Real | _getWidth (void) const
| Gets the width of this element in relation to the screen (where 1.0 = screen width).
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width/height).
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height).
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width).
void | _setParent (OverlayContainer *parent)
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width/height).
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen height).
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | _updateFromParent (void)
| Updates this elements transform based on it's parent.
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component.
const DisplayString & | getCaption (void) const
| Gets the caption for this element.
virtual const ColourValue & | getColour (void) const
| Gets the colour for this element.
Real | getHeight (void) const
| Gets the height of this element in relation to the current GuiMetricsMode.
GuiHorizontalAlignment | getHorizontalAlignment (void) const
| Gets the horizontal alignment for this element.
Real | getLeft (void) const
| Gets the left of this element in relation to the current GuiMetricsMode.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
virtual const String & | getMaterialName (void) const
| Gets the name of the material this element uses.
GuiMetricsMode | getMetricsMode (void) const
| Retrieves the current settings of how the element metrics are interpreted.
const String & | getName (void) const
| Gets the name of this overlay.
OverlayContainer * | getParent ()
| Returns the parent container.
Real | getSquaredViewDepth (const Camera *cam) const override
| Returns the squared distance between the camera and this renderable.
Real | getTop (void) const
| Gets the top of this element in relation to the current GuiMetricsMode (where 0 = top).
GuiVerticalAlignment | getVerticalAlignment (void) const
| Gets the vertical alignment for this element.
Real | getWidth (void) const
| Gets the width of this element in relation to the current GuiMetricsMode.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
ushort | getZOrder () const
| Returns the zOrder of the element.
void | hide (void)
| Hides this element if it was visible.
bool | isCloneable () const
bool | isEnabled () const
virtual bool | isKeyEnabled () const
bool | isVisible (void) const
| Returns whether or not the element is visible.
virtual void | setCaption (const DisplayString &text)
| Sets the caption on elements that support it.
void | setCloneable (bool c)
virtual void | setColour (const ColourValue &col)
| Sets the colour on elements that support it.
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the current GuiMetricsMode.
void | setEnabled (bool b)
void | setHeight (Real height)
| Sets the height of this element in relation to the current GuiMetricsMode.
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element.
void | setLeft (Real left)
| Sets the left of this element in relation to the current GuiMetricsMode.
void | setMaterial (const MaterialPtr &mat)
| Sets the the material this element will use.
void | setMaterialName (const String &matName, const String &group=DEFAULT_RESOURCE_GROUP)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | setMetricsMode (GuiMetricsMode gmm)
| Tells this element how to interpret the position and dimension values it is given.
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner in relation to the current GuiMetricsMode (where 0 = top).
void | setTop (Real Top)
| Sets the top of this element in relation to the current GuiMetricsMode (where 0 = top).
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element.
void | setVisible (bool visible)
| Shows or hides this element.
void | setWidth (Real width)
| Sets the width of this element in relation to the current GuiMetricsMode.
void | show (void)
| Shows this element if it was hidden.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members

Public Types inherited from Ogre::OverlayContainer
typedef MapIterator< ChildContainerMap > | ChildContainerIterator
typedef std::map< String, OverlayContainer * > | ChildContainerMap
typedef MapIterator< ChildMap > | ChildIterator
typedef std::map< String, OverlayElement * > | ChildMap
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Attributes inherited from Ogre::OverlayElement
static const String & | DEFAULT_RESOURCE_GROUP

## Detailed Description

OverlayElement representing a flat, single-material (or transparent) panel which can contain other elements.

This class subclasses OverlayContainer because it can contain other elements. Like other containers, if hidden it's contents are also hidden, if moved it's contents also move etc. The panel itself is a 2D rectangle which is either completely transparent, or is rendered with a single material. The texture(s) on the panel can be tiled depending on your requirements.

  This component is suitable for backgrounds and grouping other elements. Note that because it has a single repeating material it cannot have a discrete border (unless the texture has one and the texture is tiled only once). For a bordered panel, see it's subclass BorderPanelOverlayElement.

  Note that the material can have all the usual effects applied to it like multiple texture layers, scrolling / animated textures etc. For multiple texture layers, you have to set the tiling level for each layer.

## Constructor & Destructor Documentation

## PanelOverlayElement()

Ogre::PanelOverlayElement::PanelOverlayElement | ( | const String & | name | ) |

Constructor.

## ~PanelOverlayElement()

virtual Ogre::PanelOverlayElement::~PanelOverlayElement | ( |  | ) |

virtual

## Member Function Documentation

## initialise()

void Ogre::PanelOverlayElement::initialise | ( | void |  | ) |

override virtual

Initialise.

Reimplemented from Ogre::OverlayContainer.

## _releaseManualHardwareResources()

void Ogre::PanelOverlayElement::_releaseManualHardwareResources | ( |  | ) |

override virtual

Notifies that hardware resources were lost.

Reimplemented from Ogre::OverlayElement.

## _restoreManualHardwareResources()

void Ogre::PanelOverlayElement::_restoreManualHardwareResources | ( |  | ) |

override virtual

Notifies that hardware resources should be restored.

Reimplemented from Ogre::OverlayElement.

## setTiling()

void Ogre::PanelOverlayElement::setTiling | ( | Real | x,
|  | Real | y,
|  | ushort | layer = 0 )

Sets the number of times textures should repeat.

Parameters

  x | The number of times the texture should repeat horizontally
  y | The number of times the texture should repeat vertically
  layer | The texture layer to specify (only needs to be altered if you're using a multi-texture layer material)

## getTileX()

Real Ogre::PanelOverlayElement::getTileX | ( | ushort | layer = 0 | ) | const

## getTileY()

Real Ogre::PanelOverlayElement::getTileY | ( | ushort | layer = 0 | ) | const

Gets the number of times the texture should repeat vertically.

Parameters

  layer | The texture layer to specify (only needs to be altered if you're using a multi-texture layer material)

## setUV()

void Ogre::PanelOverlayElement::setUV | ( | Real | u1,
|  | Real | v1,
|  | Real | u2,
|  | Real | v2 )

Sets the texture coordinates for the panel.

## getUV()

void Ogre::PanelOverlayElement::getUV | ( | Real & | u1,
|  | Real & | v1,
|  | Real & | u2,
|  | Real & | v2 ) const

Get the uv coordinates for the panel.

## setTransparent()

void Ogre::PanelOverlayElement::setTransparent | ( | bool | isTransparent | ) |

Sets whether this panel is transparent (used only as a grouping level), or if it is actually rendered.

References isTransparent().

## isTransparent()

bool Ogre::PanelOverlayElement::isTransparent | ( | void |  | ) | const

Returns whether this panel is transparent.

Referenced by setTransparent().

## getTypeName()

const String & Ogre::PanelOverlayElement::getTypeName | ( | void |  | ) | const

override virtual

Gets the type name of the element.

All concrete subclasses must implement this.

Implements Ogre::OverlayElement.

## getRenderOperation()

void Ogre::PanelOverlayElement::getRenderOperation | ( | RenderOperation & | op | ) |

override virtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## _updateRenderQueue()

void Ogre::PanelOverlayElement::_updateRenderQueue | ( | RenderQueue * | queue | ) |

override virtual

Overridden from OverlayContainer.

Reimplemented from Ogre::OverlayContainer.

References OGRE_MAX_TEXTURE_LAYERS.

The documentation for this class was generated from the following file:

- OgrePanelOverlayElement.h